;http://members.xoom.com/segaman89/
;  ______________________________
;~|   ARKANOID V0.1 beta test    |~
;~| by Florian Clavert / Segaman |~
;~|  => segaman@caramail.com     |~
;~| last update december,23rd 99 |~
;  
	include "tios.h"
	include "graphlib.h"
	include "userlib.h"
	include "hexlib.h"
	xdef	_ti89
	xdef    _main
	xdef	_comment

;-----------------------------------------------------------------------------equates
MEM1		equ	'1'	;/mem used by the prog in KB
MEM2		equ	'2'	;\

VER1		equ	'0'
VER2		equ	'.'
VER3		equ	'1'
VER4		equ	'b'

SCREEN_X	equ	160
SCREEN_Y	equ	100

NBRICKS_X 	equ	9
NBRICKS_Y 	equ	8
POS_BRICKS_X	equ	8
POS_BRICKS_Y	equ	10
BRICKS_WIDTH	equ	16
BRICKS_HEIGHT	equ	6

BALL_SIZE	equ	7

PADDLE_SIZE	equ	24
PADDLE_POS_Y	equ	90
PADDLE_POS_X	equ	SCREEN_X/2-PADDLE_SIZE/2
LIMIT_X		equ	POS_BRICKS_X
LIMIT_X2	equ	SCREEN_X-POS_BRICKS_X

UP		equ	0
LEFT		equ	1
DOWN		equ	2
RIGHT		equ	3
SECND		equ	4


;NOTES:
;-----
;=> screen buffer adress is in A5 (always)

;-----------------------------------------------------------------------------macros
;oooooooooooooooooooooooooooooooooooooooooooooooo
FILL MACRO		;FILL x,y,w,h,c
	movem.l	d0-d4/a1,-(a7)
	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d2
	move.w	\4,d3
	move.w	\5,d4
	jsr	graphlib::fill
	move.w	#1,graphlib::choosescreen
	lea	(a5),a1
	jsr	graphlib::fill
	move.l	graphlib::plane1,a1
	jsr	graphlib::fill
	clr.w	graphlib::choosescreen
	movem.l	(a7)+,d0-d4/a1
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
TEXT MACRO		;TEXT x,y,string
	move.w	#4,-(a7)
	pea	\3(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
PUTSPRITE MACRO		;PUTSPRITE x,y,sprite - no mask needed
	movem.l	d0-d1/d3/a0-a1,-(a7)
	move.w	\1,d0
	move.w	\2,d1
	move.l	#\3@1,a0
	st	d3
	jsr	graphlib::put_sprite_mask
	move.w	#1,graphlib::choosescreen
	move.l	graphlib::plane1,a1
	move.l	#\3@2,a0
	jsr	graphlib::put_sprite_mask
	clr.w	graphlib::choosescreen
	movem.l	(a7)+,d0-d1/d3/a0-a1
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
PUTBRICK MACRO		;PUTBRICK x,y,sprite - no mask needed
	movem.l	d0-d1/d3/a0-a1,-(a7)
	move.w	\1,d0
	move.w	\2,d1
	move.l	#\3@1,a0
	st	d3
	jsr	graphlib::put_sprite_mask	;put the brick in plane0
	move.w	#1,graphlib::choosescreen

	move.l	graphlib::plane1,a1
	move.l	#\3@2,a0
	jsr	graphlib::put_sprite_mask	;put the brick in plane1

	move.l	a5,a1
	cmp.w	#0,color	;if color is #0 then disp a white brick in the buffer
	beq	\suite
	move.l	#brick255@1,a0
	bra	\suite2
\suite	move.l	#brick0@1,a0
\suite2	jsr	graphlib::put_sprite_mask	;put a black brick in the buffer

	clr.w	graphlib::choosescreen
	movem.l	(a7)+,d0-d1/d3/a0-a1
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
PUTPADDLE MACRO		;PUTPADDLE x,y,sprite,on/off - no mask needed
	movem.l	d0-d1/d3/a0-a1,-(a7)
	move.w	\1,d0
	move.w	\2,d1
	move.l	#\3@1,a0
	st	d3
	jsr	graphlib::put_sprite_mask
	move.w	#1,graphlib::choosescreen
	move.l	graphlib::plane1,a1
	move.l	#\3@2,a0
	jsr	graphlib::put_sprite_mask

	move.l	a5,a1
	move.l	#paddle_\4@1,a0
	jsr	graphlib::put_sprite_mask	;put a black or white paddle in the buffer

	clr.w	graphlib::choosescreen
	movem.l	(a7)+,d0-d1/d3/a0-a1
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
PUTBALL MACRO		;PUTBALL x,y,sprite - (mask in the data)
	movem.l	d0-d1/d3/a0-a1,-(a7)
	move.w	\1,d0
	move.w	\2,d1
	move.l	#\3@1,a0
	jsr	graphlib::put_sprite
	move.w	#1,graphlib::choosescreen
	move.l	graphlib::plane1,a1
	;move.l	#\3@2,a0			;(@1)
	jsr	graphlib::put_sprite

	;move.l	a5,a1				;affiche le sprite dans le buffer
	;jsr	graphlib::put_sprite

	clr.w	graphlib::choosescreen
	movem.l	(a7)+,d0-d1/d3/a0-a1
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
IF_ESC_PRESSED	MACRO	;IF_ESC_PRESSED (beq)label
	move.w	#%10111111,d0
	bsr	getkey
	btst.b	#0,d0
	beq	\1
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
IF_KEY_PRESSED	MACRO	;IF_KEY_PRESSED key,(beq)label
	move.w	#%11111110,d0
	bsr	getkey
	btst.b	#\1,d0
	beq	\2
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
add2	MACRO		;add2 x1,x2	; x1+x2 - destroy d0
	move.w	\1,d0
	add.w	d0,\2		;move the ball on x
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo
puthex	MACRO		;puthex x,y,n
	movem.l	d0-d7/a0-a6,-(a7)
	clr.l	d0
	move.w	\3,d0
	move.l	\2,d1
	move.l	\1,d2
	move.l	#3,d4
	jsr	hexlib::put_hex
	movem.l	(a7)+,d0-d7/a0-a6
	ENDM
;oooooooooooooooooooooooooooooooooooooooooooooooo


;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
_main:
	move.l	#3840,-(a7)
	jsr	tios::HeapAlloc
	add.w	#4,a7
	tst.w	d0
	beq	end_error
	move.w	d0,handle
	tios::DEREF	d0,a5
	bsr	clear_buffer
	bsr	new_int
	jsr	graphlib::gray4

	move.w	#0,level
START:
	bsr	clear_screen
	bsr	fill_background
	FILL	#POS_BRICKS_X,#POS_BRICKS_Y,#NBRICKS_X*BRICKS_WIDTH-1,#100-POS_BRICKS_Y-1,#1
	move.w	level,d0		;# of the level to load
	bsr	load_level

	FILL	#7,#POS_BRICKS_Y,#0,#99-POS_BRICKS_Y,#2				;background
	FILL	#SCREEN_X-1-7,#POS_BRICKS_Y,#0,#99-POS_BRICKS_Y,#2
	FILL	#POS_BRICKS_X-1,#POS_BRICKS_Y-1,#NBRICKS_X*BRICKS_WIDTH+1,#0,#2

	move.w	#PADDLE_POS_X,pad1x		;variables initialization
	move.w	#PADDLE_POS_X,old_p1x
	;move.w	#80,ballx
	;move.w	#70,bally
	;move.w	#80,old_ballx
	;move.w	#70,old_bally

	;move.w	#1,depx
	;move.w	#-1,depy


	move.w	#9,timing_ball		;vitesse balle
	move.w	#4,timing_pad		;vitesse paddle


;________________________________________________________________________________________________
;////////////////////////////////////////////////////////////////////////////////////////////////
;////////////////////////////////////////////////////////////////////////////////////////////////
;
while:
;-----------------------------------------------
	move.w	timing_pad,timer
	move.w	old_p1x,d0
	add.w	#PADDLE_SIZE/2-8/2,d0
	PUTBALL	d0,#PADDLE_POS_Y-7,no_ball

	move.w	pad1x,d0
	add.w	#PADDLE_SIZE/2-8/2,d0
	PUTBALL	d0,#PADDLE_POS_Y-7,ball

	move.w	old_p1x,d0
	cmp.w	pad1x,d0
	beq	not_refresh_pad2
	PUTPADDLE	old_p1x,#PADDLE_POS_Y,paddle_off,off
	PUTPADDLE	pad1x,#PADDLE_POS_Y,paddle,on
	bra	no_refrech2
not_refresh_pad2:
	PUTPADDLE	pad1x,#PADDLE_POS_Y,paddle,on
	PUTPADDLE	pad1x,#PADDLE_POS_Y,paddle,on
no_refrech2:
	IF_ESC_PRESSED	end
	IF_KEY_PRESSED	SECND,begin_playing
	move.w	pad1x,old_p1x
	IF_KEY_PRESSED	LEFT,left2
	IF_KEY_PRESSED	RIGHT,right2
suite_move_paddle2:
	bsr	limit_move_pad		;limit paddle movement to background
;-----------------------------------------------
\timing:
	tst.w	timer
	bne	\timing
	bra	while

begin_playing:
	move.w	pad1x,d0
	add.w	#PADDLE_SIZE/2-8/2,d0
	PUTBALL	d0,#PADDLE_POS_Y-7,no_ball

	move.w	d0,ballx
	move.w	#PADDLE_POS_Y-7-1,bally
	move.w	d0,old_ballx
	move.w	#PADDLE_POS_Y-7-1,old_bally

	move.w	#2,d0			;tirer un nbr aleatoire entre 0 et 2-1=1
	jsr	userlib::random
	move.w	#1,depx
	tst.w	d0
	bne	pas_zero
	move.w	#-1,depx
pas_zero:
	move.w	#-1,depy		;direction de la balle: vers le haut

;////////////////////////////////////////////////////////////////////////////////////////////////
;
	move.w	timing_ball,timer
	move.w	timing_pad,timer2
MAIN_LOOP:
	;move.w	timing,timer
	tst.w	timer
	bne	sauter_ball_routine		;hum, enfin voyons, faon de parler
;-----------------------------------------------ball routines
	PUTBALL	old_ballx,old_bally,no_ball
	PUTBALL	ballx,bally,ball
	move.w	ballx,old_ballx
	move.w	bally,old_bally


;TOUTES LES LIGNES SUR LES COLLISION A REVOIR:

	move.w	#PADDLE_POS_Y-BALL_SIZE,d0
	cmp.w	bally,d0
	bcs	\suite
	bsr	collision_detection_X	;inverser avec deplacement ??? (non je pense pas en fait)
	bsr	collision_detection_Y	;""
\suite:

	bsr	collision_on_paddle		;collisions sur la raquette
	;bsr	collision_on_walls		;collisions sur les murs de gauche et droite


	bsr	see_if_level_is_clear
	;puthex	#0,#0,level_finished
	tst.w	level_finished
	beq	NEXT_LEVEL

	cmp.w	#90,bally
	bhi	START

	add2	depx,ballx		;move the ball on x
	add2	depy,bally		;move the ball on y

;	bsr	clear_screen
;	move.w	#3839,d0	;display the buffer
;	move.l	#$4c00,a0
;	move.l	a5,a1
;loop	move.b	(a1)+,(a0)+
;	dbra	d0,loop

;	bsr	wait_key_pressed

;-----------------------------------------------
	move.w	timing_ball,timer
sauter_ball_routine:


	tst.w	timer2
	bne	sauter_paddle_routine		;n'ayez pas l'esprit tordu je vous prie monsieur
;-----------------------------------------------paddle routines
	move.w	old_p1x,d0
	cmp.w	pad1x,d0
	beq	not_refresh_pad
	PUTPADDLE	old_p1x,#PADDLE_POS_Y,paddle_off,off
	PUTPADDLE	pad1x,#PADDLE_POS_Y,paddle,on
	bra	no_refrech
not_refresh_pad:
	PUTPADDLE	pad1x,#PADDLE_POS_Y,paddle,on
	PUTPADDLE	pad1x,#PADDLE_POS_Y,paddle,on
no_refrech:
	IF_ESC_PRESSED	end
	move.w	pad1x,old_p1x
	IF_KEY_PRESSED	LEFT,left
	IF_KEY_PRESSED	RIGHT,right
suite_move_paddle:
	bsr	limit_move_pad		;limit paddle movement to background
;-----------------------------------------------
	move.w	timing_pad,timer2
sauter_paddle_routine:

	;move.l	#2000,d0
	;bsr	delay

;	bsr	clear_screen
;	move.w	#3839,d0	;display the buffer
;	move.l	#$4c00,a0
;	move.l	a5,a1
;loop	move.b	(a1)+,(a0)+
;	dbra	d0,loop
;	move.l	#200000,d0
;	bsr	delay

;\timing:
;	cmp.w	#0,timer
;	bne	\timing

	bra	MAIN_LOOP

;________________________________________________________________________________________________
;////////////////////////////////////////////////////////////////////////////////////////////////
;////////////////////////////////////////////////////////////////////////////////////////////////
;
end:
	jsr	graphlib::gray2
	move.w	handle,-(a7)
	jsr	tios::HeapFree
	add	#2,a7
	bra	exit

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

;-----------------------------------------------------------------------------sub routines
;oooooooooooooooooooooooooooooooooooooooooooooooo
end_error:
	jsr	graphlib::clr_scr
	TEXT	#0,#0,err1
	TEXT	#0,#0+10,err2
	TEXT	#0,#0+20,err3
	TEXT	#0,#0+30,err4
	TEXT	#0,#0+90,err5
	clr.w	(tios::kb_vars+$1C)
loop_sleep:
	tst.w	(tios::kb_vars+$1C)
	beq	loop_sleep
	clr.w	(tios::kb_vars+$1C)
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
clear_buffer:
	move.w	#1,graphlib::choosescreen
	lea	(a5),a1
	jsr	graphlib::clr_scr
	clr.w	graphlib::choosescreen
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
clear_screen:
	jsr	graphlib::clr_scr
	move.w	#1,graphlib::choosescreen
	move.l	graphlib::plane1,a1
	jsr	graphlib::clr_scr
	clr.w	graphlib::choosescreen
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
load_level:
	;d0.w must contain the number of the level to load
	;destroy d0,d1,d2,d3,d4,a0,a1

	st	color
	move.w	#NBRICKS_X-1,d1		;x tab
	move.w	#NBRICKS_Y-1,d4		;y tab
	move.w	#POS_BRICKS_X,d2	;x pos
	move.w	#POS_BRICKS_Y,d3	;y pos
	move.l	#levels,a0
	mulu.w	#NBRICKS_X*NBRICKS_Y,d0
	add.w	d0,a0
	move.l	a0,a1
level_loop_Y:
level_loop_X:
	move.b	(a0)+,d0
	cmp.b	#0,d0
	beq	no_brick
	cmp.b	#1,d0
	bne	no_brick1
	PUTBRICK	d2,d3,brick1
no_brick1:
	cmp.b	#2,d0
	bne	no_brick2
	PUTBRICK	d2,d3,brick2
no_brick2:
	cmp.b	#3,d0
	bne	no_brick3
	PUTBRICK	d2,d3,brick3
no_brick3:
no_brick:
	add.w	#BRICKS_WIDTH,d2
	dbra	d1,level_loop_X
	move.w	#NBRICKS_X-1,d1
	move.w	#POS_BRICKS_X,d2
	add.w	#BRICKS_HEIGHT,d3
	dbra	d4,level_loop_Y

;*** Charge le level dans le tableau world
	move.l	a1,a0			;#levels
	move.l	#world,a1
	move.w	#NBRICKS_X*NBRICKS_Y-1,d0
loop_load_level:
	move.b	(a0)+,(a1)+
	dbra	d0,loop_load_level

	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
fill_background:				;destroy d0,d1,d2,d3,d4,a0,a1
	move.l	graphlib::plane0,a0
	move.l	graphlib::plane1,a1
	move.l	#%11110000111100001111000011110000,d3
	move.l	#%00001111000011110000111100001111,d4
	move.w	#24,d1
fill_backgr:
	move.w	#3,d2
fill_four_lines:
	move.w	#4,d0
fill_a_line:
	move.l	d3,(a0)+
	move.l	d4,(a1)+
	dbra	d0,fill_a_line
	add.l	#10,a0
	add.l	#10,a1
	dbra	d2,fill_four_lines
	not.l	d3
	not.l	d4
	dbra	d1,fill_backgr
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
getkey:
	move.w	d0,$600018
	move.w	#8,d0
\loop	dbra	d0,\loop
	move.b	$60001b,d0
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
new_int:
	move.w	#$0700,d0
	trap	#1
	bclr.b	#2,$600001
	move.l	$64,oldint1
	move.l	$60+6*4,oldint6
	move.l	#newint1,$64		;set the new interupt
	move.l	#newint6,$60+6*4
	bset.b	#2,$600001
	trap	#1
	rts
oldint1	dc.l 0				;data to save old int#1 adress...
oldint6	dc.l 0				;...and old int#6 adress

newint1					;create a timer interuption (timer & timer2 are
	tst.w	timer			; automatically decreased.
	beq	\jump
	sub.w	#1,timer
\jump	tst.w	timer2
	beq	\jump2
	sub.w	#1,timer2
\jump2	rte
newint6	rte				;newint6 do...nothing !
;oooooooooooooooooooooooooooooooooooooooooooooooo
exit:
	move.w	#$0700,d0
	trap	#1
	bclr.b	#2,$600001		;this line allow low memory writing
	move.l	oldint1,$64		;set the old interupt
	move.l	oldint6,$60+6*4
	bset.b	#2,$600001
	trap	#1
	rts				;quit
;oooooooooooooooooooooooooooooooooooooooooooooooo
left:
	sub.w	#1,pad1x
	bra	suite_move_paddle
right:
	add.w	#1,pad1x
	bra	suite_move_paddle
;oooooooooooooooooooooooooooooooooooooooooooooooo
;oooooooooooooooooooooooooooooooooooooooooooooooo
left2:
	sub.w	#1,pad1x
	bra	suite_move_paddle2
right2:
	add.w	#1,pad1x
	bra	suite_move_paddle2
;oooooooooooooooooooooooooooooooooooooooooooooooo

delay:		;wait for the delay in d0.l
\loop:
	tst.l	d0
	beq	\suite_loop
	sub.l	#1,d0
	bra	\loop
\suite_loop:
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
limit_move_pad:
	cmp.w	#LIMIT_X2-PADDLE_SIZE,pad1x	;limit on left
	blt	no_limited_x2
	move.w	#LIMIT_X2-PADDLE_SIZE,pad1x
no_limited_x2:

	cmp.w	#LIMIT_X,pad1x			;limit on right
	bgt	no_limited_x
	move.w	#LIMIT_X,pad1x
no_limited_x:
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
getpixel:	;get a pixel at (d0,d1) in the buffer - return the color in d0 (1=set ; 0=clr)
		;destroy d0,d1,d2,d3,a0
	move.l	a5,a0
	move.w	d0,d2
	move.w	#15,d3
	sub.w	d2,d3
	move.w	d3,d2
	lsr.w	#3,d0
	mulu.w	#30,d1
	add.w	d1,a0
	btst.w	d2,0(a0,d0)
	beq	\suite
	move.w	#1,d0
	bra	\suite2
\suite	clr.w	d0
\suite2	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
wait_key_pressed:		;wait until a key have been pressed
	move.l	d0,-(a7)
\wait	clr.w	d0
	bsr	getkey
	cmp.b	#$FF,d0
	beq	\wait
	move.l	(a7)+,d0
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
collision_detection_X:
	move.l	#coll_X,a1
	move.w	#14-1,d7	;first others registers are destroyed by getpixel
loop_collx:
	clr.w	d0
	clr.w	d1
	move.b	(a1)+,d0
	move.b	(a1)+,d1
	add.w	ballx,d0
	add.w	bally,d1
	sub.w	#1,d0
	sub.w	#1,d1
;-----------------\
	clr.l	d5
	clr.l	d6
	move.w	d0,d5		;save d0 & d1 in d5 & d6
	move.w	d1,d6
;-----------------/
	bsr	getpixel
	cmp.w	#1,d0
	bne	no_neg_x
	neg.w	depx
;-----------------\
	sub.w	#POS_BRICKS_X,d5
	sub.w	#POS_BRICKS_Y,d6
	divu.w	#BRICKS_WIDTH,d5
	divu.w	#BRICKS_HEIGHT,d6
	move.w	d5,d2
	move.w	d6,d3

	move.l	#world,a0

	;puthex	#0,#0,d2		;posx
	;puthex	#0,#1,d3		;posy

	;add.l	#2,a0

	mulu.w	#NBRICKS_X,d3
	add.w	d2,d3
	add.w	d3,a0

	;move.b	(a0),d7
	;puthex	#0,#2,d7		;couleur

;Efface un brique dans level[a0] pos[d5][d6]
	mulu.w	#BRICKS_WIDTH,d5
	mulu.w	#BRICKS_HEIGHT,d6
	add.w	#8,d5
	add.w	#10,d6

	cmp.w	#150,d5				;zzzzzzzzzzzzzzzzzzzz???????????????a revoir
	bhi	\pas_effacer_brick
	cmp.w	#5,d5
	ble	\pas_effacer_brick

	clr.b	(a0)			;del a brick
	clr.w	color
	PUTBRICK	d5,d6,brick0

\pas_effacer_brick:

	;bsr	wait_key_pressed

;	;cmp.b	#0,0(a0,d6.w)
;	;bhi	del_brick

;-----------------/
	rts
no_neg_x:
	dbra	d7,loop_collx

	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
collision_detection_Y:
	move.l	#coll_Y,a1
	move.w	#14-1,d7	;first others registers are destroyed by getpixel
loop_colly:
	clr.l	d0
	clr.l	d1
	move.b	(a1)+,d0
	move.b	(a1)+,d1
	add.w	ballx,d0
	add.w	bally,d1
	sub.w	#1,d0
	sub.w	#1,d1
;-----------------\
	clr.l	d5
	clr.l	d6
	move.w	d0,d5		;save d0 & d1 in d5 & d6
	move.w	d1,d6
;-----------------/
	bsr	getpixel	;be careful, destroy a0,d0,d1,d2,d3
	cmp.w	#1,d0
	bne	no_neg_y
	neg.w	depy
;-----------------\
	sub.w	#POS_BRICKS_X,d5
	sub.w	#POS_BRICKS_Y,d6
	divu.w	#BRICKS_WIDTH,d5
	divu.w	#BRICKS_HEIGHT,d6
	move.w	d5,d2
	move.w	d6,d3

	move.l	#world,a0

	;puthex	#0,#0,d2		;posx
	;puthex	#0,#1,d3		;posy

	;add.l	#2,a0

	mulu.w	#NBRICKS_X,d3
	add.w	d2,d3
	add.w	d3,a0

	;move.b	(a0),d7
	;puthex	#0,#2,d7		;couleur

;Efface une brique dans level[a0] pos[d5][d6]
	mulu.w	#BRICKS_WIDTH,d5
	mulu.w	#BRICKS_HEIGHT,d6
	add.w	#8,d5
	add.w	#10,d6

	cmp.w	#80,d6				;zzzzzzzzzzzzzzzzzzzz???????????????a revoir
	bhi	\pas_effacer_brick
	cmp.w	#POS_BRICKS_Y-1,d6
	ble	\pas_effacer_brick

	clr.b	(a0)
	clr.w	color
	PUTBRICK	d5,d6,brick0

\pas_effacer_brick:

	;bsr	wait_key_pressed

;	;cmp.b	#0,0(a0,d6.w)
;	;bhi	del_brick

;-----------------/
	rts
no_neg_y:
	dbra	d7,loop_colly
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
;putpixel:
;	move.l	a5,a0
;	move.w	d0,d2
;	move.w	#15,d3
;	sub.w	d2,d3
;	move.w	d3,d2
;	lsr.w	#3,d0
;	mulu.w	#30,d1
;	add.w	d1,a0
;	bset.w	d2,0(a0,d0)
;	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
;del_brick:
;	;move.b	#0,0(a0,d6.w)	;clear the brick in the buffer

;	move.b	0(a0,d6.w),d0
;	puthex	#0,#0,d0
;	bsr	wait_key_pressed
;	;bsr	clear_screen
;	;move.w	#0,d0
;	;bsr	load_level
;	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
see_if_level_is_clear:
	movem.l	d0-d1/a0,-(a7)

	move.l	#world,a0
	move.w	#NBRICKS_X,d0
	mulu.w	#NBRICKS_Y,d0
	sub.w	#1,d0			;? a enlever ?
	clr.l	d1
\loop:
	add.b	(a0)+,d1
	dbra	d0,\loop
	move.w	d1,level_finished
	movem.l	(a7)+,d0-d1/a0
	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
collision_on_paddle:					;a revoir+optimiser !!!!!!
	move.w bally,a0					;fait avec tigcc ;-)
	move.w #BALL_SIZE,a1
	move.l a0,d0
	add.l a1,d0
	move.w #PADDLE_POS_Y,a0
	cmp.l d0,a0
	bge .L2
	move.w ballx,a0
	move.w #BALL_SIZE,a1
	move.l a0,d0
	add.l a1,d0
	move.w pad1x,a0
	move.w #PADDLE_SIZE/2,a1
	move.l a0,d1
	add.l a1,d1
	cmp.l d0,d1
	ble .L3
	move.w ballx,a0
	move.w #BALL_SIZE,a1
	move.l a0,d0
	add.l a1,d0
	move.w pad1x,a0
	cmp.l d0,a0
	bge .L3
	move.w #-1,depx
.L3:
	move.w ballx,a0
	move.w pad1x,a1
	move.w #PADDLE_SIZE/2,a2
	move.l a1,d0
	add.l a2,d0
	cmp.l a0,d0
	bge .L2
	move.w ballx,a0
	move.w pad1x,a1
	move.w #PADDLE_SIZE,a2
	move.l a1,d0
	add.l a2,d0
	cmp.l a0,d0
	ble .L2
	move.w #1,depx
.L4:
.L2:
.L1:
	rts

;oooooooooooooooooooooooooooooooooooooooooooooooo
;collision_on_walls:
;	cmp.w	#POS_BRICKS_X,ballx
;	bhi	pas_limit_left
;	neg.w	depx
;	move.w	#POS_BRICKS_X,ballx
;pas_limit_left:
;	cmp.w	#160-(POS_BRICKS_X)-(BALL_SIZE),ballx
;	bcs	pas_limit_right
;	neg.w	depx
;	move.w	#160-(POS_BRICKS_X)-(BALL_SIZE),ballx
;pas_limit_right:
;	rts
;oooooooooooooooooooooooooooooooooooooooooooooooo
NEXT_LEVEL:
	cmp.w	#3,level
	beq	end
	add.w	#1,level
	bra	START
;oooooooooooooooooooooooooooooooooooooooooooooooo

;-----------------------------------------------------------------------------bitmaps
	include "sprites.asm"

;-----------------------------------------------------------------------------misc datas
world:					;array were the level will be stored
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0
	dc.b 0,0,0,0,0,0,0,0,0

	include "levels.asm"	;the levels

coll_X:		;collision table wich will change x displacement of the ball
	dc.b 0,1
	dc.b 0,2
	dc.b 0,3
	dc.b 0,4
	dc.b 0,5
	dc.b 0,6
	dc.b 0,7

	dc.b 8,1
	dc.b 8,2
	dc.b 8,3
	dc.b 8,4
	dc.b 8,5
	dc.b 8,6
	dc.b 8,7

coll_Y:		;collision table wich will change y displacement of the ball
	dc.b 1,0	;x,y
	dc.b 2,0
	dc.b 3,0
	dc.b 4,0
	dc.b 5,0
	dc.b 6,0
	dc.b 7,0

	dc.b 1,8
	dc.b 2,8
	dc.b 3,8
	dc.b 4,8
	dc.b 5,8
	dc.b 6,8
	dc.b 7,8

;-----------------------------------------------------------------------------vars
x	dc.w 0		;misc vars
y	dc.w 0
pad1x	dc.w 0		;X pos of the paddle #1
old_p1x	dc.w 0		;old X pos of the paddle #1
ballx	dc.w 0
bally	dc.w 0
old_ballx	dc.w 0
old_bally	dc.w 0
depx	dc.w 0
depy	dc.w 0
level	dc.w 0		;actual level
color	dc.w 0		;1 or 0 for the color of the brick to put in the buffer
level_finished	dc.w 0	;equ 0 if the level is clear

handle	dc.w 0
timer	dc.w 0		;this var is decreased automatically each time int#1 is actived
timer2	dc.w 0		;same as timer
timing_ball	dc.w 0		;pause pour balle
timing_pad	dc.w 0		;pause pour raquette

;-----------------------------------------------------------------------------text datas
the_end	dc.b "CONGRATULATIONS !!!",0
the_end2 dc.b "You have finished the demo",0
err1	dc.b "Error: not enough memory",0
err2	dc.b "Delete some bad programs",0
err3	dc.b "and try again ;)",0
err4	dc.b "you need ",MEM1,MEM2,"KB of free ram",0
err5	dc.b "hit a key to quit...",0
_comment	dc.b "ARKANOID V",VER1,VER2,VER3,VER4," by Florian Clavert",0
	end